async function getAmounts(start:Date, end:Date, groupBy: string){
    let isoStart = start.toISOString().substring(0, 10);
    let isoEnd = end.toISOString().substring(0, 10);
    let url = `/amounts/groupby=${groupBy}&dateStart=${isoStart}&dateEnd=${isoEnd}`;
    // callApi(url, callback);
    return graphQl(
`{
    amounts(groupby: "${groupBy}", dateStart: "${isoStart}", dateEnd: "${isoEnd}") {
        date
        value
    }
}`);
    // callback([
    //     { date: "2017-01-01", value: 50 },
    //     { date: "2017-06-01", value: 30 },
    //     { date: "2018-01-01", value: 70 }]);
}

function getRegions(callback: any){
    return callApi('/regions', callback);
}

function getSeries(callback: any){
    callApi('/series', callback);
}

async function callApi(url: string, callback: any) {
    fetch(encodeURI(url), {headers: {'Accept': 'application/ld+json'}})
        .then(response => response.json())
        .then(data => {
            callback(data["hydra:member"]);
        })
        .catch((err) => {
            console.error(err);
        });
}

async function graphQl(query: string) {
    return fetch('graphql', {
        method: 'POST',
        body: JSON.stringify({ query }),
        headers: {
            accept: 'application/json',
            'content-type': 'application/json',
        }
    }).then(response => response.json())
        .then(({ data }) => {
            return data;
        });
}

export const ApiService = {
    getAmounts,
    getRegions,
    getSeries
}